<?php

/*
 +--------------------------------------------------------------------+
 | CiviCRM version 1.8                                                |
 +--------------------------------------------------------------------+
 | Copyright CiviCRM LLC (c) 2004-2007                                |
 +--------------------------------------------------------------------+
 | This file is a part of CiviCRM.                                    |
 |                                                                    |
 | CiviCRM is free software; you can copy, modify, and distribute it  |
 | under the terms of the Affero General Public License Version 1,    |
 | March 2002.                                                        |
 |                                                                    |
 | CiviCRM is distributed in the hope that it will be useful, but     |
 | WITHOUT ANY WARRANTY; without even the implied warranty of         |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
 | See the Affero General Public License for more details.            |
 |                                                                    |
 | You should have received a copy of the Affero General Public       |
 | License along with this program; if not, contact CiviCRM LLC       |
 | at info[AT]civicrm[DOT]org.  If you have questions about the       |
 | Affero General Public License or the licensing  of CiviCRM,        |
 | see the CiviCRM license FAQ at http://civicrm.org/licensing        |
 +--------------------------------------------------------------------+
*/

/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id: Preferences.php 10543 2007-07-25 09:43:12Z shot $
 *
 */

$GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject'] =  null;
$GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject'] =  null;

require_once 'CRM/Core/DAO/Preferences.php';

/**
 *
 */
class CRM_Core_BAO_Preferences extends CRM_Core_DAO_Preferences {
    

    

     function &systemObject( ) {
        if ( ! $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject'] ) {
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject'] =& new CRM_Core_DAO_Preferences( );
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject']->domain_id  = CRM_Core_Config::domainID( );
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject']->is_domain  = true;
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject']->contact_id = null;
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject']->find( true );
        }
        return $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject'];
    }

     function &userObject( $userID = null ) {
        if ( ! $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject'] ) {
            if ( ! $userID ) {
                $session =& CRM_Core_Session::singleton( );
                $userID  =  $session->get( 'userID' );
            }
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject'] =& new CRM_Core_DAO_Preferences( );
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject']->domain_id  = CRM_Core_Config::domainID( );
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject']->is_domain  = false;
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject']->contact_id = $userID;
            $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject']->find( true );
        }
        return $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_userObject'];
    }

     function value( $name, $system = true, $userID = null ) {
        if ( $system ) {
            $object = CRM_Core_BAO_Preferences::systemObject( );
        } else {
            $object = CRM_Core_BAO_Preferences::userObject( $userID );
        }

        if ( $name == 'address_sequence' ) {
            return CRM_Core_BAO_Preferences::addressSequence( $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject']->address_format );
        }

        return $GLOBALS['_CRM_CORE_BAO_PREFERENCES']['_systemObject']->$name;
    }

     function addressSequence( $format ) {
        // also compute and store the address sequence
        $addressSequence = array( 'street_address',
                                  'supplemental_address_1',
                                  'supplemental_address_2',
                                  'city',
                                  'county',
                                  'state_province',
                                  'postal_code',
                                  'country');

        // get the field sequence from the format
        $newSequence = array();
        foreach($addressSequence as $field) {
            if (substr_count($format, $field)) {
                $newSequence[strpos($format, $field)] = $field;
            }
        }
        ksort($newSequence);
        
        // add the addressSequence fields that are missing in the addressFormat
        // to the end of the list, so that (for example) if state_province is not
        // specified in the addressFormat it's still in the address-editing form
        $newSequence = array_merge($newSequence, $addressSequence);
        $newSequence = array_unique($newSequence);
        return $newSequence;
    }

     function valueOptions( $name, $system = true, $userID = null, $localize = false ) {
        if ( $system ) {
            $object = CRM_Core_BAO_Preferences::systemObject( );
        } else {
            $object = CRM_Core_BAO_Preferences::userObject( $userID );
        }

        $optionValue = $object->$name;
        require_once 'CRM/Core/OptionGroup.php';
        $groupValues = CRM_Core_OptionGroup::values( $name, false, false, $localize );
        
        $returnValues = array( );
        foreach ( $groupValues as $gn => $gv ) {
            $returnValues[$gv] = 0;
        }
        if ( ! empty( $optionValue ) ) { 
            require_once 'CRM/Core/BAO/CustomOption.php';
            $dbValues = explode( CRM_CORE_BAO_CUSTOMOPTION_VALUE_SEPERATOR,
                              substr( $optionValue, 1, -1 ) );
            if ( ! empty( $dbValues ) ) {
                foreach ( $dbValues as $key => $val ) {
                    $returnValues[$groupValues[$val]] = 1;
                }
            }
        }
        
        return $returnValues;
    }

}

?>