<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_tableName'] =  'civicrm_msg_template';
$GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_MessageTemplates extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Message Template ID
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Which Domain owns this contact
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * Descriptive title of message
     *
     * @var string
     */
    var $msg_title;
    /**
     * Subject for email message.
     *
     * @var string
     */
    var $msg_subject;
    /**
     * Text formatted message
     *
     * @var text
     */
    var $msg_text;
    /**
     * HTML formatted message
     *
     * @var text
     */
    var $msg_html;
    /**
     *
     * @var boolean
     */
    var $is_active;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_msg_template
     */
    function CRM_Core_DAO_MessageTemplates() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'msg_title' => array(
                    'name' => 'msg_title',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Msg Title') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'msg_subject' => array(
                    'name' => 'msg_subject',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Msg Subject') ,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'msg_text' => array(
                    'name' => 'msg_text',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Msg Text') ,
                    'rows' => 10,
                    'cols' => 75,
                ) ,
                'msg_html' => array(
                    'name' => 'msg_html',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Msg Html') ,
                    'rows' => 10,
                    'cols' => 75,
                ) ,
                'is_active' => array(
                    'name' => 'is_active',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                    'title' => ts('Is Active') ,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_import'] = array();
            $fields = &CRM_Core_DAO_MessageTemplates::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_import']['msg_template'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_export'] = array();
            $fields = &CRM_Core_DAO_MessageTemplates::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_export']['msg_template'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_MESSAGETEMPLATES']['_export'];
    }
}
?>