<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_PRICESET']['_tableName'] =  'civicrm_price_set';
$GLOBALS['_CRM_CORE_DAO_PRICESET']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICESET']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICESET']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICESET']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_PRICESET']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_PriceSet extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Price Set
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Which domain owns this price set
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * Variable name/programmatic handle for this group
     *
     * @var string
     */
    var $name;
    /**
     * Friendly name
     *
     * @var string
     */
    var $title;
    /**
     * Is this price set active
     *
     * @var boolean
     */
    var $is_active;
    /**
     * Description and/or help text to display before fields in form.
     *
     * @var text
     */
    var $help_pre;
    /**
     * Description and/or help text to display after fields in form.
     *
     * @var text
     */
    var $help_post;
    /**
     * Optional Javascript script function(s) included on the form with this price_set. Can be used for conditional
     *
     * @var string
     */
    var $javascript;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_price_set
     */
    function CRM_Core_DAO_PriceSet() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICESET']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICESET']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICESET']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICESET']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICESET']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'name' => array(
                    'name' => 'name',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Name') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'title' => array(
                    'name' => 'title',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Title') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'is_active' => array(
                    'name' => 'is_active',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
                'help_pre' => array(
                    'name' => 'help_pre',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Help Pre') ,
                ) ,
                'help_post' => array(
                    'name' => 'help_post',
                    'type' => CRM_UTILS_TYPE_T_TEXT,
                    'title' => ts('Help Post') ,
                ) ,
                'javascript' => array(
                    'name' => 'javascript',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Javascript') ,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICESET']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PRICESET']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_PRICESET']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICESET']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICESET']['_import'] = array();
            $fields = &CRM_Core_DAO_PriceSet::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PRICESET']['_import']['price_set'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PRICESET']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICESET']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_PRICESET']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_PRICESET']['_export'] = array();
            $fields = &CRM_Core_DAO_PriceSet::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_PRICESET']['_export']['price_set'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_PRICESET']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_PRICESET']['_export'];
    }
}
?>