<?php

/*
 * Copyright (C) 2007
 * Licensed to CiviCRM under the Academic Free License version 3.0.
 *
 * Written and contributed by Ideal Solution, LLC (http://www.idealso.com)
 *
 */

/**
 * @package CRM
 * @author Marshal Newrock <marshal@idealso.com>
 * $Id: AuthorizeNet.php 9800 2007-06-07 02:46:32Z marshal $
 **/

$GLOBALS['_CRM_EVENT_PAYMENT_AUTHORIZENET']['_singleton'] =  null;

require_once 'CRM/Core/Payment/AuthorizeNet.php';

class CRM_Event_Payment_AuthorizeNet extends CRM_Core_Payment_AuthorizeNet {
    /** 
     * We only need one instance of this object. So we use the singleton 
     * pattern and cache the instance in this variable 
     *
     * @var object 
     * @static 
     */
    
    
    /**
     * Constructor
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return void
     */
    function CRM_Event_Payment_AuthorizeNet( $mode, &$paymentProcessor ) {
        parent::CRM_Core_Payment_AuthorizeNet( $mode, $paymentProcessor );
    }

    /**
     * singleton function used to manage this object
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return object
     * @static
     */
     function &singleton( $mode, &$paymentProcessor ) {
        if ($GLOBALS['_CRM_EVENT_PAYMENT_AUTHORIZENET']['_singleton'] === null ) {
            $GLOBALS['_CRM_EVENT_PAYMENT_AUTHORIZENET']['_singleton'] =& new CRM_Event_Payment_AuthorizeNet( $mode, $paymentProcessor );
        }
        return $GLOBALS['_CRM_EVENT_PAYMENT_AUTHORIZENET']['_singleton'];
    }

}